/**
 * @file SplitBase.h
 * @brief Xvbgo[̊NXłB
 * @author Shinji Watanabe
 * @date Dec. 28, 2008
 */

#pragma once

#include "FootyView.h"

class CFooty;

#define SPLIT_WNDCLASSNAME	L"Splitter"
#define SPLIT_PROPNAME		L"SplitterClass"

class CSplitBase
{
public:
	CSplitBase();
	virtual ~CSplitBase();

	bool Create( HWND hWndParent, HINSTANCE hInstance );
	void DestroySplitBar();
	void OnBaseWindowMove(int x,int y,int nWidth,int nHeight);
	inline HWND GetWnd(){return m_hWnd;}
	inline int GetX() const { return m_x; }
	inline int GetY() const { return m_y; }

	virtual bool MoveWin(int x,int y,int nWidth,int nHeight){ return false; }// by Tetr@pod, return false;̓_~[
	
	void SetViews(CFooty *pFooty, CFootyView *pTopView)
	{
		m_pFooty = pFooty;// by Tetr@pod, _uNbNɂ镪̂
		m_pViews = pTopView;
		m_nMode = SPLIT_DUAL;
	}
	void SetViews(CFooty *pFooty, CFootyView *pTopView,CSplitBase *pSplit)
	{
		m_pFooty = pFooty;// by Tetr@pod
		m_pViews = pTopView;
		m_pOtherSplit = pSplit;
		m_nMode = SPLIT_QUAD;
	}

	void SetVisible(bool bVisible);

	enum fixed_num
	{
		SPLIT_SIZE = 4,

		// S͈̔ by Tetr@pod
		SPLIT_CENTER_RANGE1 = 32,// 
		SPLIT_CENTER_RANGE2 = 32,// E
	};

protected:

private:
	static LRESULT CALLBACK SplitWinProc(HWND hWnd,UINT msg,WPARAM wParam,LPARAM lParam);
	LRESULT MainProc(UINT msg,WPARAM wParam,LPARAM lParam);
	// virtual void OnMouseDown(int x,int y);
	virtual void OnMouseDown(int x,int y){}// ʏɕύX
	virtual void OnMouseMove(int x,int y){}
	virtual void OnMouseUp(int x,int y);

	virtual void OnMouseDouble(int x,int y){}// by Tetr@pod


public:
protected:
	enum SplitMode
	{
		SPLIT_DUAL,						//!< fAr[
		SPLIT_QUAD,						//!< NAbhr[
	};

	bool m_bDrag;						//!< ݃hbOH
	int m_x,m_y;						//!< ݂̈ʒu
	int m_nBaseX,m_nBaseY;				//!< x[XEBhËʒu
	int m_nBaseWidth,m_nBaseHeight;		//!< x[XEBhȆ傫
	bool m_bIsCenter;					//!< hbOH by Tetr@pod

	HWND m_hWnd2;						//!< EBhEnh ʏ̂
	
	CFootyView *m_pViews;				//!< Footỹr[
	CFooty *m_pFooty;					//!< Footy by Tetr@pod
	CSplitBase *m_pOtherSplit;			//!< ̃Xvbgo[
	SplitMode m_nMode;					//!< ݂̃r[[h

private:
	HWND m_hWnd;						//!< EBhEnh
	bool m_bVisible;					//!< \ԂH
};

/*[EOF]*/
